

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Yellow
#property indicator_color3 Red

extern int intensity = 18;
extern int periods = 800;
double gda_84[];
double gda_88[];
double gda_92[];

int init() {
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2, Yellow);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 2, Red);
   SetIndexBuffer(0, gda_84);
   SetIndexBuffer(1, gda_88);
   SetIndexBuffer(2, gda_92);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   return (0);
}

int start() {
   int li_0;
   double ld_8;
   double ld_16;
   double ld_80;
   int li_4 = IndicatorCounted();
   double ld_32 = 0;
   double ld_40 = 0;
   double ld_48 = 0;
   double ld_56 = 0;
   double ld_64 = 0;
   double ld_72 = 0;
   double ld_88 = 0;
   double ld_96 = 0;
   if (li_4 > 0) li_4--;
   if (periods > Bars || periods == 0) li_0 = Bars - intensity;
   else li_0 = periods - intensity;
   for (int li_104 = li_0; li_104 >= 0; li_104--) {
      ld_96 = High[iHighest(NULL, 0, MODE_HIGH, intensity, li_104)];
      ld_88 = Low[iLowest(NULL, 0, MODE_LOW, intensity, li_104)];
      ld_80 = (High[li_104] + Low[li_104]) / 2.0;
      ld_32 = 0.66 * ((ld_80 - ld_88) / (ld_96 - ld_88) - 0.5) + 0.05 * ld_40;
      ld_32 = MathMin(MathMax(ld_32, -0.999), 0.999);
      gda_84[li_104] = MathLog((ld_32 + 1.0) / (1 - ld_32)) / 2.0 + ld_64 / 2.0;
      ld_40 = ld_32;
      ld_64 = gda_84[li_104];
   }
   bool li_108 = TRUE;
   for (li_104 = li_0 - 2; li_104 >= 0; li_104--) {
      ld_16 = gda_84[li_104];
      ld_8 = gda_84[li_104 + 1];
      if ((ld_16 < 0.0 && ld_8 > 0.0) || ld_16 < 0.0) li_108 = FALSE;
      if ((ld_16 > 0.0 && ld_8 < 0.0) || ld_16 > 0.0) li_108 = TRUE;
      if (!li_108) {
         gda_92[li_104] = ld_16;
         gda_88[li_104] = 0.0;
      } else {
         gda_88[li_104] = ld_16;
         gda_92[li_104] = 0.0;
      }
   }
   return (0);
}